﻿type Matrix<'a> =
  { m11: 'a; m12: 'a; m13: 'a
    m21: 'a; m22: 'a; m23: 'a
    m31: 'a; m32: 'a; m33: 'a } with

  // fails to compile with the next line
  static member inline (/) (m, s) =
  // successfully compiles with the next line
  //static member inline (/) ((m: Matrix<'b>), (s: 'b)) : Matrix<'b> =
    { m11 = m.m11 / s; m12 = m.m12 / s; m13 = m.m13 / s
      m21 = m.m21 / s; m22 = m.m22 / s; m23 = m.m23 / s
      m31 = m.m31 / s; m32 = m.m32 / s; m33 = m.m33 / s }

let inline determinant m =
  m.m11 * m.m22 * m.m33
  + m.m12 * m.m23 * m.m31
  + m.m13 * m.m21 * m.m32
  - m.m31 * m.m22 * m.m13
  - m.m32 * m.m23 * m.m11
  - m.m33 * m.m21 * m.m12
  
let inline inverse m =
  { m11 = m.m22 * m.m33 - m.m32 * m.m23; m12 = m.m13 * m.m32 - m.m33 * m.m12; m13 = m.m12 * m.m23 - m.m22 * m.m13
    m21 = m.m23 * m.m31 - m.m33 * m.m21; m22 = m.m11 * m.m33 - m.m31 * m.m13; m23 = m.m13 * m.m21 - m.m23 * m.m11
    m31 = m.m21 * m.m32 - m.m31 * m.m22; m32 = m.m12 * m.m31 - m.m32 * m.m11; m33 = m.m11 * m.m22 - m.m21 * m.m12 }
    / (determinant m)


[<EntryPoint>]
let main _ =
    0
